diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/energy/examples/generic-battery-wifiradio-example.cc ns-3.40/src/energy/examples/generic-battery-wifiradio-example.cc
--- ns-3.39/src/energy/examples/generic-battery-wifiradio-example.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.40/src/energy/examples/generic-battery-wifiradio-example.cc	2023-09-27 13:30:37.642839000 -0700
@@ -0,0 +1,293 @@
+/*
+ * Copyright (c) 2023 Tokushima University, Japan
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ */
+
+/*
+ *  Node 1 <-------------- distanceToRx ------------> Node2
+ *  (SoC 89%)                                        (SoC 95%)
+ *
+ *  This example is based on the basic-energy-model-test created by He Wu.
+ *  The objective is to demonstrate the use of a GenericBatteryModel with
+ *  the WifiRadioEnergyModel. The WifiRadioEnergyModel was created to work
+ *  specifically with the BasicEnergySource, therefore, the current example
+ *  should be considered a prototype until WifiRadioEnergyModel can be
+ *  revised and thoroughly tested with the GenericBatterySource.
+ *
+ *  In the example, 2 wifi nodes are created each with a GenericBatterySource
+ *  (Li-Ion battery type) is created with 4 cells (2 series, 2 parallel).
+ *  The simulation runs for 3600 secs. Tx, Rx and Idle consumption values
+ *  have been exaggerated for demonstration purposes. At the end of the simulation,
+ *  the State of Charge (Soc %) and remaining capacity in Jouls for each node is
+ *  displayed.
+ *
+ */
+
+#include <ns3/core-module.h>
+#include <ns3/energy-module.h>
+#include <ns3/internet-module.h>
+#include <ns3/mobility-module.h>
+#include <ns3/network-module.h>
+#include <ns3/wifi-module.h>
+
+#include <sstream>
+#include <string>
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE("GenericBatteryWifiRadioExample");
+
+/**
+ * Print a received packet
+ *
+ * \param from sender address
+ * \return a string with the details of the packet: dst {IP, port}, time.
+ */
+inline std::string
+PrintReceivedPacket(Address& from)
+{
+    InetSocketAddress iaddr = InetSocketAddress::ConvertFrom(from);
+
+    std::ostringstream oss;
+    oss << " Received one packet! Socket: " << iaddr.GetIpv4() << " port: " << iaddr.GetPort()
+        << "\n";
+
+    return oss.str();
+}
+
+/**
+ * \param socket Pointer to socket.
+ *
+ * Packet receiving sink.
+ */
+void
+ReceivePacket(Ptr<Socket> socket)
+{
+    Ptr<Packet> packet;
+    Address from;
+    while ((packet = socket->RecvFrom(from)))
+    {
+        if (packet->GetSize() > 0)
+        {
+            NS_LOG_DEBUG(PrintReceivedPacket(from));
+        }
+    }
+}
+
+/**
+ * \param socket Pointer to socket.
+ * \param pktSize Packet size.
+ * \param n Pointer to node.
+ * \param pktCount Number of packets to generate.
+ * \param pktInterval Packet sending interval.
+ *
+ * Generate Traffic
+ */
+static void
+GenerateTraffic(Ptr<Socket> socket,
+                uint32_t pktSize,
+                Ptr<Node> n,
+                uint32_t pktCount,
+                Time pktInterval)
+{
+    if (pktCount > 0)
+    {
+        socket->Send(Create<Packet>(pktSize));
+        Simulator::Schedule(pktInterval,
+                            &GenerateTraffic,
+                            socket,
+                            pktSize,
+                            n,
+                            pktCount - 1,
+                            pktInterval);
+    }
+    else
+    {
+        socket->Close();
+    }
+}
+
+/**
+ * Trace function for remaining energy at node.
+ *
+ * \param oldValue Old value
+ * \param remainingEnergy New value
+ */
+void
+RemainingEnergy(double oldValue, double remainingEnergy)
+{
+    NS_LOG_DEBUG(" Remaining energy Node 1 = " << remainingEnergy << " J");
+}
+
+int
+main(int argc, char* argv[])
+{
+    LogComponentEnableAll(LogLevel(LOG_PREFIX_TIME | LOG_PREFIX_FUNC));
+    LogComponentEnable("GenericBatteryWifiRadioExample", LOG_LEVEL_DEBUG);
+
+    std::string phyMode("DsssRate1Mbps");
+    double rss = -80;          // dBm
+    uint32_t packetSize = 200; // bytes
+    bool verbose = false;
+
+    // simulation parameters
+    uint32_t numPackets = 10000; // number of packets to send
+    double interval = 1;         // seconds
+    double startTime = 0.0;      // seconds
+    double distanceToRx = 100.0; // meters
+
+    CommandLine cmd(__FILE__);
+    cmd.AddValue("phyMode", "Wifi Phy mode", phyMode);
+    cmd.AddValue("rss", "Intended primary RSS (dBm)", rss);
+    cmd.AddValue("packetSize", "size of application packet sent (Bytes)", packetSize);
+    cmd.AddValue("numPackets", "Total number of packets to send", numPackets);
+    cmd.AddValue("startTime", "Simulation start time (seconds)", startTime);
+    cmd.AddValue("distanceToRx", "X-Axis distance between nodes (meters)", distanceToRx);
+    cmd.AddValue("verbose", "Turn on all device log components", verbose);
+    cmd.Parse(argc, argv);
+
+    Time interPacketInterval = Seconds(interval);
+
+    Config::SetDefault("ns3::WifiRemoteStationManager::FragmentationThreshold",
+                       StringValue("2200"));
+    Config::SetDefault("ns3::WifiRemoteStationManager::RtsCtsThreshold", StringValue("2200"));
+    Config::SetDefault("ns3::WifiRemoteStationManager::NonUnicastMode", StringValue(phyMode));
+
+    NodeContainer nodeContainer;
+    nodeContainer.Create(2);
+
+    WifiHelper wifi;
+    if (verbose)
+    {
+        WifiHelper::EnableLogComponents();
+    }
+    wifi.SetStandard(WIFI_STANDARD_80211b);
+
+    ////////////////////////
+    // Wifi PHY and MAC   //
+    ////////////////////////
+
+    YansWifiPhyHelper wifiPhy;
+    YansWifiChannelHelper wifiChannel;
+    wifiChannel.SetPropagationDelay("ns3::ConstantSpeedPropagationDelayModel");
+    wifiChannel.AddPropagationLoss("ns3::FriisPropagationLossModel");
+
+    Ptr<YansWifiChannel> wifiChannelPtr = wifiChannel.Create();
+    wifiPhy.SetChannel(wifiChannelPtr);
+
+    WifiMacHelper wifiMac;
+    wifi.SetRemoteStationManager("ns3::ConstantRateWifiManager",
+                                 "DataMode",
+                                 StringValue(phyMode),
+                                 "ControlMode",
+                                 StringValue(phyMode));
+
+    wifiMac.SetType("ns3::AdhocWifiMac");
+    NetDeviceContainer devices = wifi.Install(wifiPhy, wifiMac, nodeContainer);
+
+    //////////////////
+    //   Mobility   //
+    //////////////////
+
+    MobilityHelper mobility;
+    Ptr<ListPositionAllocator> positionAlloc = CreateObject<ListPositionAllocator>();
+    positionAlloc->Add(Vector(0.0, 0.0, 0.0));
+    positionAlloc->Add(Vector(2 * distanceToRx, 0.0, 0.0));
+    mobility.SetPositionAllocator(positionAlloc);
+    mobility.SetMobilityModel("ns3::ConstantPositionMobilityModel");
+    mobility.Install(nodeContainer);
+
+    //////////////////////
+    //  Energy Model    //
+    //////////////////////
+
+    // Use a preset PANASONIC Li-Ion batteries arranged in a cell pack (2 series, 2 parallel)
+    GenericBatteryModelHelper batteryHelper;
+    EnergySourceContainer energySourceContainer =
+        batteryHelper.Install(nodeContainer, PANASONIC_CGR18650DA_LION);
+    batteryHelper.SetCellPack(energySourceContainer, 2, 2);
+
+    Ptr<GenericBatteryModel> battery0 =
+        DynamicCast<GenericBatteryModel>(energySourceContainer.Get(0));
+    Ptr<GenericBatteryModel> battery1 =
+        DynamicCast<GenericBatteryModel>(energySourceContainer.Get(1));
+
+    // Energy consumption quantities have been exaggerated for
+    // demonstration purposes, real consumption values are much smaller.
+    WifiRadioEnergyModelHelper radioEnergyHelper;
+    radioEnergyHelper.Set("TxCurrentA", DoubleValue(4.66));
+    radioEnergyHelper.Set("RxCurrentA", DoubleValue(0.466));
+    radioEnergyHelper.Set("IdleCurrentA", DoubleValue(0.466));
+    DeviceEnergyModelContainer deviceModels =
+        radioEnergyHelper.Install(devices, energySourceContainer);
+
+    /////////////////////
+    // Internet stack  //
+    /////////////////////
+
+    InternetStackHelper internet;
+    internet.Install(nodeContainer);
+
+    Ipv4AddressHelper ipv4;
+    ipv4.SetBase("10.1.1.0", "255.255.255.0");
+    Ipv4InterfaceContainer i = ipv4.Assign(devices);
+
+    TypeId tid = TypeId::LookupByName("ns3::UdpSocketFactory");
+    Ptr<Socket> recvSink = Socket::CreateSocket(nodeContainer.Get(1), tid); // node 1, receiver
+    InetSocketAddress local = InetSocketAddress(Ipv4Address::GetAny(), 80);
+    recvSink->Bind(local);
+    recvSink->SetRecvCallback(MakeCallback(&ReceivePacket));
+
+    Ptr<Socket> source = Socket::CreateSocket(nodeContainer.Get(0), tid); // node 0, sender
+    InetSocketAddress remote = InetSocketAddress(Ipv4Address::GetBroadcast(), 80);
+    source->SetAllowBroadcast(true);
+    source->Connect(remote);
+
+    /////////////////////
+    // Trace Sources   //
+    /////////////////////
+
+    battery1->TraceConnectWithoutContext("RemainingEnergy", MakeCallback(&RemainingEnergy));
+
+    Ptr<DeviceEnergyModel> radioConsumptionModel =
+        battery1->FindDeviceEnergyModels("ns3::WifiRadioEnergyModel").Get(0);
+
+    /////////////////////
+    // Traffic Setup   //
+    /////////////////////
+    Simulator::Schedule(Seconds(startTime),
+                        &GenerateTraffic,
+                        source,
+                        packetSize,
+                        nodeContainer.Get(0),
+                        numPackets,
+                        interPacketInterval);
+
+    Simulator::Stop(Seconds(3600));
+    Simulator::Run();
+
+    NS_LOG_DEBUG(" *Remaining Capacity * "
+                 << "| Node 0: " << battery0->GetRemainingEnergy() << " J "
+                 << "| Node 1: " << battery1->GetRemainingEnergy() << " J");
+    NS_LOG_DEBUG(" *SoC * "
+                 << "| Node 0: " << battery0->GetStateOfCharge() << " % "
+                 << "| Node 1: " << battery1->GetStateOfCharge() << " % ");
+
+    Simulator::Destroy();
+
+    return 0;
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/energy/helper/energy-harvester-container.cc ns-3.40/src/energy/helper/energy-harvester-container.cc
--- ns-3.39/src/energy/helper/energy-harvester-container.cc	2023-07-05 14:23:47.785427300 -0700
+++ ns-3.40/src/energy/helper/energy-harvester-container.cc	2023-09-27 13:30:37.642839000 -0700
@@ -105,7 +105,7 @@
 EnergyHarvesterContainer::Add(EnergyHarvesterContainer container)
 {
     NS_LOG_FUNCTION(this << &container);
-    for (Iterator i = container.Begin(); i != container.End(); i++)
+    for (auto i = container.Begin(); i != container.End(); i++)
     {
         m_harvesters.push_back(*i);
     }
@@ -143,9 +143,7 @@
 EnergyHarvesterContainer::DoDispose()
 {
     // call Object::Dispose for all EnergyHarvester objects
-    for (std::vector<Ptr<EnergyHarvester>>::iterator i = m_harvesters.begin();
-         i != m_harvesters.end();
-         i++)
+    for (auto i = m_harvesters.begin(); i != m_harvesters.end(); i++)
     {
         (*i)->Dispose();
     }
@@ -156,9 +154,7 @@
 EnergyHarvesterContainer::DoInitialize()
 {
     // call Object::Initialize for all EnergyHarvester objects
-    for (std::vector<Ptr<EnergyHarvester>>::iterator i = m_harvesters.begin();
-         i != m_harvesters.end();
-         i++)
+    for (auto i = m_harvesters.begin(); i != m_harvesters.end(); i++)
     {
         (*i)->Initialize();
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/energy/helper/energy-harvester-helper.cc ns-3.40/src/energy/helper/energy-harvester-helper.cc
--- ns-3.39/src/energy/helper/energy-harvester-helper.cc	2023-07-05 14:23:47.785427300 -0700
+++ ns-3.40/src/energy/helper/energy-harvester-helper.cc	2023-09-27 13:30:37.642839000 -0700
@@ -43,8 +43,7 @@
 EnergyHarvesterHelper::Install(EnergySourceContainer sourceContainer) const
 {
     EnergyHarvesterContainer container;
-    for (EnergySourceContainer::Iterator i = sourceContainer.Begin(); i != sourceContainer.End();
-         ++i)
+    for (auto i = sourceContainer.Begin(); i != sourceContainer.End(); ++i)
     {
         Ptr<EnergyHarvester> harvester = DoInstall(*i);
         container.Add(harvester);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/energy/helper/energy-harvester-helper.h ns-3.40/src/energy/helper/energy-harvester-helper.h
--- ns-3.39/src/energy/helper/energy-harvester-helper.h	2023-07-05 14:23:47.785427300 -0700
+++ ns-3.40/src/energy/helper/energy-harvester-helper.h	2023-09-27 13:30:37.642839000 -0700
@@ -21,10 +21,11 @@
 #ifndef ENERGY_HARVESTER_HELPER_H
 #define ENERGY_HARVESTER_HELPER_H
 
+#include "energy-harvester-container.h"
+#include "energy-source-container.h"
+
 #include "ns3/attribute.h"
-#include "ns3/energy-harvester-container.h"
 #include "ns3/energy-harvester.h"
-#include "ns3/energy-source-container.h"
 #include "ns3/energy-source.h"
 #include "ns3/node-container.h"
 #include "ns3/object-factory.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/energy/helper/energy-model-helper.cc ns-3.40/src/energy/helper/energy-model-helper.cc
--- ns-3.39/src/energy/helper/energy-model-helper.cc	2023-07-05 14:23:47.785427300 -0700
+++ ns-3.40/src/energy/helper/energy-model-helper.cc	2023-09-27 13:30:37.642839000 -0700
@@ -42,7 +42,7 @@
 EnergySourceHelper::Install(NodeContainer c) const
 {
     EnergySourceContainer container;
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         Ptr<EnergySource> src = DoInstall(*i);
         container.Add(src);
@@ -105,8 +105,8 @@
 {
     NS_ASSERT(deviceContainer.GetN() <= sourceContainer.GetN());
     DeviceEnergyModelContainer container;
-    NetDeviceContainer::Iterator dev = deviceContainer.Begin();
-    EnergySourceContainer::Iterator src = sourceContainer.Begin();
+    auto dev = deviceContainer.Begin();
+    auto src = sourceContainer.Begin();
     while (dev != deviceContainer.End())
     {
         // check to make sure source and net device are on the same node
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/energy/helper/energy-source-container.cc ns-3.40/src/energy/helper/energy-source-container.cc
--- ns-3.39/src/energy/helper/energy-source-container.cc	2023-07-05 14:23:47.785427300 -0700
+++ ns-3.40/src/energy/helper/energy-source-container.cc	2023-09-27 13:30:37.642839000 -0700
@@ -93,7 +93,7 @@
 void
 EnergySourceContainer::Add(EnergySourceContainer container)
 {
-    for (Iterator i = container.Begin(); i != container.End(); i++)
+    for (auto i = container.Begin(); i != container.End(); i++)
     {
         m_sources.push_back(*i);
     }
@@ -122,7 +122,7 @@
 EnergySourceContainer::DoDispose()
 {
     // call Object::Dispose for all EnergySource objects
-    for (std::vector<Ptr<EnergySource>>::iterator i = m_sources.begin(); i != m_sources.end(); i++)
+    for (auto i = m_sources.begin(); i != m_sources.end(); i++)
     {
         (*i)->DisposeDeviceModels();
         (*i)->Dispose();
@@ -134,7 +134,7 @@
 EnergySourceContainer::DoInitialize()
 {
     // call Object::Start for all EnergySource objects
-    for (std::vector<Ptr<EnergySource>>::iterator i = m_sources.begin(); i != m_sources.end(); i++)
+    for (auto i = m_sources.begin(); i != m_sources.end(); i++)
     {
         (*i)->Initialize();
         (*i)->InitializeDeviceModels();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/energy/helper/generic-battery-model-helper.cc ns-3.40/src/energy/helper/generic-battery-model-helper.cc
--- ns-3.39/src/energy/helper/generic-battery-model-helper.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.40/src/energy/helper/generic-battery-model-helper.cc	2023-09-27 13:30:37.642839000 -0700
@@ -0,0 +1,156 @@
+/*
+ * Copyright (c) 2023 Tokushima University, Japan.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ */
+
+#include "generic-battery-model-helper.h"
+
+namespace ns3
+{
+
+GenericBatteryModelHelper::GenericBatteryModelHelper()
+{
+    m_batteryModel.SetTypeId("ns3::GenericBatteryModel");
+}
+
+GenericBatteryModelHelper::~GenericBatteryModelHelper()
+{
+}
+
+void
+GenericBatteryModelHelper::Set(std::string name, const AttributeValue& v)
+{
+    m_batteryModel.Set(name, v);
+}
+
+Ptr<EnergySource>
+GenericBatteryModelHelper::DoInstall(Ptr<Node> node) const
+{
+    NS_ASSERT(node != nullptr);
+    Ptr<EnergySource> energySource = m_batteryModel.Create<EnergySource>();
+    NS_ASSERT(energySource != nullptr);
+    energySource->SetNode(node);
+    return energySource;
+}
+
+Ptr<EnergySourceContainer>
+GenericBatteryModelHelper::Install(NodeContainer c) const
+{
+    Ptr<EnergySourceContainer> batteryContainer = CreateObject<EnergySourceContainer>();
+    for (auto i = c.Begin(); i != c.End(); i++)
+    {
+        batteryContainer->Add(DoInstall(*i));
+    }
+    return batteryContainer;
+}
+
+Ptr<EnergySource>
+GenericBatteryModelHelper::Install(Ptr<Node> node, BatteryModel bm) const
+{
+    NS_ASSERT(node != nullptr);
+    Ptr<EnergySource> energySource = m_batteryModel.Create<EnergySource>();
+    NS_ASSERT(energySource != nullptr);
+
+    energySource->SetAttribute("FullVoltage", DoubleValue(g_batteryPreset[bm].vFull));
+    energySource->SetAttribute("MaxCapacity", DoubleValue(g_batteryPreset[bm].qMax));
+
+    energySource->SetAttribute("NominalVoltage", DoubleValue(g_batteryPreset[bm].vNom));
+    energySource->SetAttribute("NominalCapacity", DoubleValue(g_batteryPreset[bm].qNom));
+
+    energySource->SetAttribute("ExponentialVoltage", DoubleValue(g_batteryPreset[bm].vExp));
+    energySource->SetAttribute("ExponentialCapacity", DoubleValue(g_batteryPreset[bm].qExp));
+
+    energySource->SetAttribute("InternalResistance",
+                               DoubleValue(g_batteryPreset[bm].internalResistance));
+    energySource->SetAttribute("TypicalDischargeCurrent",
+                               DoubleValue(g_batteryPreset[bm].typicalCurrent));
+    energySource->SetAttribute("CutoffVoltage", DoubleValue(g_batteryPreset[bm].cuttoffVoltage));
+
+    energySource->SetAttribute("BatteryType", EnumValue(g_batteryPreset[bm].batteryType));
+
+    energySource->SetNode(node);
+    return energySource;
+}
+
+EnergySourceContainer
+GenericBatteryModelHelper::Install(NodeContainer c, BatteryModel bm) const
+{
+    EnergySourceContainer batteryContainer;
+    for (auto i = c.Begin(); i != c.End(); i++)
+    {
+        Ptr<EnergySource> energySource = Install(*i, bm);
+        batteryContainer.Add(energySource);
+    }
+    return batteryContainer;
+}
+
+void
+GenericBatteryModelHelper::SetCellPack(Ptr<EnergySource> energySource,
+                                       uint8_t series,
+                                       uint8_t parallel) const
+{
+    NS_ASSERT_MSG(series > 0, "The value of cells in series must be > 0");
+    NS_ASSERT_MSG(parallel > 0, "The value of cells in parallel must be > 0");
+    NS_ASSERT(energySource != nullptr);
+
+    DoubleValue vFull;
+    DoubleValue q;
+    DoubleValue vExp;
+    DoubleValue qExp;
+    DoubleValue vNom;
+    DoubleValue qNom;
+    DoubleValue r;
+
+    // Get the present values of the battery cell
+    energySource->GetAttribute("FullVoltage", vFull);
+    energySource->GetAttribute("MaxCapacity", q);
+
+    energySource->GetAttribute("NominalVoltage", vNom);
+    energySource->GetAttribute("NominalCapacity", qNom);
+
+    energySource->GetAttribute("ExponentialVoltage", vExp);
+    energySource->GetAttribute("ExponentialCapacity", qExp);
+
+    energySource->GetAttribute("InternalResistance", r);
+
+    // Configuring the Cell packs
+    energySource->SetAttribute("FullVoltage", DoubleValue(vFull.Get() * series));
+    energySource->SetAttribute("MaxCapacity", DoubleValue(q.Get() * parallel));
+
+    energySource->SetAttribute("NominalVoltage", DoubleValue(vNom.Get() * series));
+    energySource->SetAttribute("NominalCapacity", DoubleValue(qNom.Get() * parallel));
+
+    energySource->SetAttribute("ExponentialVoltage", DoubleValue(vExp.Get() * series));
+    energySource->SetAttribute("ExponentialCapacity", DoubleValue(qExp.Get() * parallel));
+
+    energySource->SetAttribute("InternalResistance", DoubleValue(r.Get() * (series / parallel)));
+}
+
+void
+GenericBatteryModelHelper::SetCellPack(EnergySourceContainer energySourceContainer,
+                                       uint8_t series,
+                                       uint8_t parallel) const
+{
+    NS_ASSERT_MSG(energySourceContainer.GetN() > 0, "This energy container is empty");
+
+    for (auto i = energySourceContainer.Begin(); i != energySourceContainer.End(); i++)
+    {
+        SetCellPack(*i, series, parallel);
+    }
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/energy/helper/generic-battery-model-helper.h ns-3.40/src/energy/helper/generic-battery-model-helper.h
--- ns-3.39/src/energy/helper/generic-battery-model-helper.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.40/src/energy/helper/generic-battery-model-helper.h	2023-09-27 13:30:37.642839000 -0700
@@ -0,0 +1,124 @@
+/*
+ * Copyright (c) 2023 Tokushima University, Japan.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ */
+
+#ifndef GENERIC_BATTERY_MODEL_HELPER_H_
+#define GENERIC_BATTERY_MODEL_HELPER_H_
+
+#include "energy-model-helper.h"
+
+#include <ns3/generic-battery-model.h>
+#include <ns3/node.h>
+
+namespace ns3
+{
+
+/**
+ * \ingroup energy
+ * \brief Creates and assign an assortment of BatteryModels to Nodes.
+ *
+ */
+class GenericBatteryModelHelper : public EnergySourceHelper
+{
+  public:
+    GenericBatteryModelHelper();
+    ~GenericBatteryModelHelper() override;
+
+    /**
+     * Sets one of the attributes of underlying EnergySource.
+     *
+     * \param name Name of attribute to set.
+     * \param v Value of the attribute.
+     */
+    void Set(std::string name, const AttributeValue& v) override;
+
+    /**
+     * This function installs energy sources in a group of nodes in a
+     * node container. An energy source (Li-Ion battery) with default values
+     * is used on each node.
+     *
+     * \param c The node container
+     * \returns An EnergySourceContainer which contains all the EnergySources.
+     */
+    Ptr<EnergySourceContainer> Install(NodeContainer c) const;
+
+    /**
+     * This function installs an energy source (battery) into a node.
+     *
+     * \param node The node object.
+     * \param bm The battery model that will be install to the node.
+     * \returns A pointer to the energy source object used.
+     */
+    Ptr<EnergySource> Install(Ptr<Node> node, BatteryModel bm) const;
+
+    /**
+     * This function installs energy sources in a group of nodes in a
+     * node container.
+     *
+     * \param c The node container.
+     * \param bm The battery model that will be install to the nodes in the node container.
+     * \returns An EnergySourceContainer which contains all the EnergySources.
+     */
+    EnergySourceContainer Install(NodeContainer c, BatteryModel bm) const;
+
+    /**
+     * This function takes an existing energy source and transform its values to form
+     * a group of connected identical cells. The values of the newly formed cell block
+     * depends on the connection of the cells defined by the user
+     * (number of cells connected in series, number of cells connected in parallel).
+     *
+     * \param energySource The energy source used.
+     * \param series The number of cells connected in series.
+     * \param parallel The number of cells connected in parallel.
+     */
+    void SetCellPack(Ptr<EnergySource> energySource, uint8_t series, uint8_t parallel) const;
+
+    /**
+     * This function takes an existing energy source container and transform the values
+     * of each of its containing energy sources to form groups of connected identical cells.
+     * The values of the newly formed cell blocks for each energy source
+     * depends on the connection of the cells defined by the user
+     * (number of cells connected in series, number of cells connected in parallel).
+     *
+     * \param energySourceContainer The energy source container used.
+     * \param series The number of cells connected in series.
+     * \param parallel The number of cells connected in parallel.
+     */
+    void SetCellPack(EnergySourceContainer energySourceContainer,
+                     uint8_t series,
+                     uint8_t parallel) const;
+
+  private:
+    /**
+     * Child classes of EnergySourceHelper only have to implement this function,
+     * to create and aggregate an EnergySource object onto a single node. Rest of
+     * the installation process (eg. installing EnergySource on set of nodes) is
+     * implemented in the EnergySourceHelper base class.
+     *
+     * \param node Pointer to node where the energy source is to be installed.
+     * \returns Pointer to the created EnergySource.
+     */
+    Ptr<EnergySource> DoInstall(Ptr<Node> node) const override;
+
+  private:
+    ObjectFactory m_batteryModel; //!< The energy source (battery) used by this helper.
+};
+
+} // namespace ns3
+
+#endif /* GENERIC_BATTERY_MODEL_HELPER_H_ */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/energy/model/basic-energy-harvester.h ns-3.40/src/energy/model/basic-energy-harvester.h
--- ns-3.39/src/energy/model/basic-energy-harvester.h	2023-07-05 14:23:47.789427300 -0700
+++ ns-3.40/src/energy/model/basic-energy-harvester.h	2023-09-27 13:30:37.642839000 -0700
@@ -21,17 +21,16 @@
 #ifndef BASIC_ENERGY_HARVESTER
 #define BASIC_ENERGY_HARVESTER
 
-#include <iostream>
-
-// include from ns-3
+#include "device-energy-model.h"
 #include "energy-harvester.h"
 
-#include "ns3/device-energy-model.h"
 #include "ns3/event-id.h"
 #include "ns3/nstime.h"
 #include "ns3/random-variable-stream.h"
 #include "ns3/traced-value.h"
 
+#include <iostream>
+
 namespace ns3
 {
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/energy/model/device-energy-model-container.cc ns-3.40/src/energy/model/device-energy-model-container.cc
--- ns-3.39/src/energy/model/device-energy-model-container.cc	2023-07-05 14:23:47.789427300 -0700
+++ ns-3.40/src/energy/model/device-energy-model-container.cc	2023-09-27 13:30:37.642839000 -0700
@@ -89,7 +89,7 @@
 DeviceEnergyModelContainer::Add(DeviceEnergyModelContainer container)
 {
     NS_LOG_FUNCTION(this << &container);
-    for (Iterator i = container.Begin(); i != container.End(); i++)
+    for (auto i = container.Begin(); i != container.End(); i++)
     {
         m_models.push_back(*i);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/energy/model/device-energy-model-container.h ns-3.40/src/energy/model/device-energy-model-container.h
--- ns-3.39/src/energy/model/device-energy-model-container.h	2023-07-05 14:23:47.789427300 -0700
+++ ns-3.40/src/energy/model/device-energy-model-container.h	2023-09-27 13:30:37.642839000 -0700
@@ -22,7 +22,7 @@
 #ifndef DEVICE_ENERGY_MODEL_CONTAINER_H
 #define DEVICE_ENERGY_MODEL_CONTAINER_H
 
-#include "ns3/device-energy-model.h"
+#include "device-energy-model.h"
 
 #include <stdint.h>
 #include <vector>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/energy/model/energy-source.cc ns-3.40/src/energy/model/energy-source.cc
--- ns-3.39/src/energy/model/energy-source.cc	2023-07-05 14:23:47.789427300 -0700
+++ ns-3.40/src/energy/model/energy-source.cc	2023-09-27 13:30:37.642839000 -0700
@@ -22,7 +22,8 @@
  * Modifications made by: Cristiano Tapparello <cristiano.tapparello@rochester.edu>
  */
 
-#include <ns3/energy-source.h>
+#include "energy-source.h"
+
 #include <ns3/log.h>
 
 namespace ns3
@@ -171,8 +172,7 @@
     {
         double totalHarvestedPower = 0.0;
 
-        std::vector<Ptr<EnergyHarvester>>::const_iterator harvester;
-        for (harvester = m_harvesters.begin(); harvester != m_harvesters.end(); harvester++)
+        for (auto harvester = m_harvesters.begin(); harvester != m_harvesters.end(); harvester++)
         {
             totalHarvestedPower += (*harvester)->GetPower();
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/energy/model/energy-source.h ns-3.40/src/energy/model/energy-source.h
--- ns-3.39/src/energy/model/energy-source.h	2023-07-05 14:23:47.789427300 -0700
+++ ns-3.40/src/energy/model/energy-source.h	2023-09-27 13:30:37.642839000 -0700
@@ -26,8 +26,8 @@
 #define ENERGY_SOURCE_H
 
 #include "device-energy-model-container.h" // #include "device-energy-model.h"
+#include "energy-harvester.h"
 
-#include "ns3/energy-harvester.h"
 #include "ns3/node.h"
 #include "ns3/object.h"
 #include "ns3/ptr.h"
